#pragma once

#include "..\..\DuiLib\UIlib.h"
#include "DuiDefine.h"
#include "UserImageActor.h"
#include "UIListCommonDefine.hpp"
#include "WorkGroupModel.h"
#include "AddUserListData.h"
#include "chatdlg.h"

using namespace DuiLib;

struct AddChatListItemInfo
{
	bool folder;
	bool empty;
	CDuiString id;
	CDuiString logo;
	CDuiString nick_name;
	CDuiString organization;
	CDuiString position;
	CDuiString tel;
};

class CAddChatWnd : public WindowImplBase, 
	private IGTWASActorEvent ,
	private IGTMessengerActorEvent,
	public IUserImageActorObserver
{
    DUI_DECLARE_MESSAGE_MAP()
    DUI_DECLARE_CUSTOM_MSG_MAP()
public:
	CAddChatWnd(CWnd* pParent, int nType);
	CAddChatWnd(WindowImplBase* pParent, int nType);
	~CAddChatWnd();

	void InitClassData();
	LPCTSTR GetWindowClassName() const;
	void InitWindow();
	void OnPrepare(TNotifyUI& msg);
	void SetRequestID(LPCTSTR strID);
	void OnSearchUser();
	int  GetSelectCount();

	virtual CDuiString GetSkinFile();
	virtual CDuiString GetSkinFolder();
	virtual void OnFinalMessage(HWND hWnd);
	virtual LRESULT OnKillFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnNcHitTest(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	Node* AddNode(const AddChatListItemInfo& item, Node* parent, const NE_MEMBER_DATA* pMembereData, GTUserStatusType status);
	void ResizeList();
	void InitMemberList(const std::vector<ORG_MEMBER_DATA> &memberVector);
	static int __cdecl        ItemComareFunc(void *pvlocale,const void *elem1, const void *elem2);
	static int __cdecl        MemberDataItemComareFunc(void *pvlocale,const void *elem1, const void *elem2);
	void UpdateMemberStatus(LPCWSTR strUserId);
	void UpdateCheckStatus(LPCWSTR strUserId,  bool Enable);
	void ChangeMyStatus(GTUserStatusType eMyStatus);
	bool RemoveNode(Node* node);
	void RemoveAllMenberList();
	void InitList();
	bool SendUserListToParent();
	void SetParentChatDlg(CChatDlg* pDlg);
	void SetParentSmsSendWnd(CSMSSendWnd* pSmsWnd); // The same reason as "SetParentChatDlg"
	void SetWindowPosition(CRect rcParent);
	void SetListItemStatus();
	void SetInChatRoom(CString strAllUserID);
	void SetItemEnable(CString strUserID);
	void SetCheckItemEnable(CButtonUI* item_check, CString strUserID, const NE_MEMBER_DATA* pMembereData, GTUserStatusType status);
	virtual void OnUserImageActor_OnResponseUserImageInfo(CString strUserId);
	virtual bool OnGTWASActor_ResponseGetEmployeeInfo(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const NE_MEMBER_DATA_LIST &list, NTRequestEmpInfoType reqEmpInfoType, int nGroupID);

private:
	static UINT _DownloadThread(LPVOID pParam);
	static void CALLBACK _OnStatusCallBack(HINTERNET hInternet, DWORD_PTR dwContext, DWORD dwInternetStatus, LPVOID lpvStatusInformation, DWORD dwStatusInformationLength);

	void DownloadPicture(CString strURL);
	void DownloadThread();
	void CloseAllInternetHandle();
	void OnUserImageUpdated(CString strUserId);
	void UpdateProfileImage(CString strUserId);

    void _OnNotifySetFocus(TNotifyUI& msg);
    void _OnNotifyKillFocus(TNotifyUI& msg);
    void _OnNotifyHeaderClick(TNotifyUI& msg);
    void _OnNotifyHeaderDrag(TNotifyUI& msg);
    void _OnNotifyReturn(TNotifyUI& msg);
    void _OnNotifyEscape(TNotifyUI& msg);

    void _OnCtrlCloseBtnClick(TNotifyUI& msg);
    void _OnCtrlSearchLabelClick(TNotifyUI& msg);
    void _OnCtrlSearchBtnClick(TNotifyUI& msg);
    void _OnCtrlSearchCancelClick(TNotifyUI& msg);
    void _OnCtrlAddChatItemCheckClick(TNotifyUI& msg);
    void _OnCtrlInviteOKClick(TNotifyUI& msg);
    void _OnCtrlInviteCancelClick(TNotifyUI& msg);

    LRESULT _OnMsgKeyDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
private:
	CString			m_strInChatRoom;
	CString			m_strSearchWord;
	CRect			m_rcClient;
	CDuiString		m_strID;
	trid_t			m_trid;
	NE_MEMBER_DATA	m_userData;
	CDuiString		m_strMyID;
	CWinThread*		m_pImageDownloadThread;
	vector<CAddUserListData*>	m_vecMemberData;

	CString			 m_sServer; 
	CString			m_sObject; 
	//INTERNET_PORT	m_nPort;
	//DWORD			m_dwServiceType;
	HINTERNET		m_hInternetSession;
	HINTERNET		m_hHttpConnection;
	HINTERNET		m_hHttpFile;
	BOOL			m_bAbort;
	BOOL			m_bSafeToClose;
	CFile			m_FileToWrite;
	CDialogBuilder  m_dlgBuilder;
	Node*			root_node_;
	CDuiRect		text_padding_;
	CWnd*			m_pCWndParent;
	WindowImplBase* m_pDUIParent;
	CChatDlg*		m_pParentChatDlg;
	CSMSSendWnd*    m_pParentSmsSendWnd;
	int				m_nParentType;
};

